update results r
left join (
	select @rrow := @rrow + 1 as row, r.resultId
	from results r
	cross join (select @rrow := 0) as rrow
) as rr on rr.resultId = r.resultId
left join (
	select @erow := @erow + 1 as row, e.cardId 
	from electronicpunchingcards e 
	cross join (select @erow := 0) as erow
	where e.electronicPunchingCardType = 'SI' 
) as e on e.row = rr.row
set r.electronicpunchingcardId = e.cardId
;


update results r
inner join (
	select r.resultId
	, row_number() over() as rn
	from results r
) rr on rr.resultId = r.resultId
inner join (
	select e.cardId
    , row_number() over() as rn
	from electronicpunchingcards e 
	where e.electronicPunchingCardType = 'SI' 
) e on e.rn = rr.rn
set r.electronicpunchingcardId = e.cardId
;
